View a markdown version of this page

AgentCore ゲートウェイからリソースを読み取る - Amazon Bedrock AgentCore

AgentCore ゲートウェイからリソースを読み取る

特定のリソースを読み取るには、ゲートウェイの MCP エンドポイントに POST リクエストを行い、リクエスト本文の メソッドresources/readとして を指定し、リソースの URI を指定します。

POST /mcp HTTP/1.1 Host: ${GatewayEndpoint} Content-Type: application/json Authorization: ${Authorization header} ${RequestBody}

以下の値を置き換えます:

レスポンスは、各エントリに urimimeType、および text (テキストコンテンツの場合) または blob (base64 でエンコードされたバイナリコンテンツの場合) が含まれるcontents配列を返します。

注記

resources/read オペレーションは、リクエストをダウンストリーム MCP サーバーにライブでプロキシします。リソース URI は、 によって返される raw URI です resources/list (ターゲットプレフィックスなし)。

注記

複数のターゲットが同じリソース URI を公開する場合、ゲートウェイはリクエストを最も低いresourcePriority値でターゲットにルーティングします。

重要

uri パラメータは、サニタイズせずにダウンストリーム MCP サーバーターゲットに渡されます。ユーザーが提供するリソース URI には、SSRF 攻撃やローカルファイルシステムパスの読み取り ( など) を目的とした悪意のある URL エンドポイントが含まれている可能性がありますfile:///etc/passwd。を呼び出す前に、予想される URIs スキームとパターンの許可リストに対してリソース URI を検証しますresources/read。信頼された MCP URIs のみを使用します。 resources/list

リソースを読み取るためのコードサンプル

ゲートウェイからリソースを読み取る例を表示するには、次のいずれかの方法を選択します。

curl
  1. 次の curl リクエストは、ID のゲートウェイconfig://app-settingsを介して URI のリソースを読み取るリクエストの例を示していますmygateway-abcdefghij

    curl -X POST \ https://mygateway-abcdefghij.gateway.bedrock-agentcore.us-west-2.amazonaws.com/mcp \ -H "Content-Type: application/json" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -d '{ "jsonrpc": "2.0", "id": "read-resource-request", "method": "resources/read", "params": { "uri": "config://app-settings" } }'
Python requests package
  1. import requests import json def read_resource(gateway_url, access_token, resource_uri): headers = { "Content-Type": "application/json", "Authorization": f"Bearer {access_token}" } payload = { "jsonrpc": "2.0", "id": "read-resource-request", "method": "resources/read", "params": { "uri": resource_uri } } response = requests.post(gateway_url, headers=headers, json=payload) return response.json() # Example usage gateway_url = "https://${GatewayEndpoint}/mcp" # Replace with your actual gateway endpoint access_token = "${AccessToken}" # Replace with your actual access token result = read_resource( gateway_url, access_token, "config://app-settings" # Replace with the resource URI from resources/list ) print(json.dumps(result, indent=2))
MCP Client
  1. from mcp import ClientSession from mcp.client.streamable_http import streamablehttp_client from pydantic import AnyUrl import asyncio async def execute_mcp( url, token, resource_uri, headers=None ): default_headers = { "Authorization": f"Bearer {token}" } headers = {**default_headers, **(headers or {})} async with streamablehttp_client( url=url, headers=headers, ) as ( read_stream, write_stream, callA, ): async with ClientSession(read_stream, write_stream) as session: # 1. Perform initialization handshake print("Initializing MCP...") _init_response = await session.initialize() print(f"MCP Server Initialize successful! - {_init_response}") # 2. Read specific resource print(f"Reading resource: {resource_uri}") resource_response = await session.read_resource(uri=AnyUrl(resource_uri)) for content in resource_response.contents: print(f"URI: {content.uri}, MIME: {content.mimeType}") if hasattr(content, 'text') and content.text: print(f"Text: {content.text}") elif hasattr(content, 'blob') and content.blob: print(f"Blob (base64): {content.blob[:100]}...") return resource_response async def main(): url = "https://${GatewayEndpoint}/mcp" token = "your_bearer_token_here" resource_uri = "config://app-settings" await execute_mcp( url=url, token=token, resource_uri=resource_uri ) if __name__ == "__main__": asyncio.run(main())
Strands MCP Client
  1. 注: ストランド SDK リソースのサポートは異なる場合があります。最も信頼性の高いresources/read実装には、上記の MCP クライアントアプローチを使用します。

    from strands.tools.mcp.mcp_client import MCPClient from mcp.client.streamable_http import streamablehttp_client def create_streamable_http_transport(mcp_url: str, access_token: str): return streamablehttp_client(mcp_url, headers={"Authorization": f"Bearer {access_token}"}) def run_agent(mcp_url: str, access_token: str): mcp_client = MCPClient(lambda: create_streamable_http_transport(mcp_url, access_token)) with mcp_client: result = mcp_client.read_resource_sync(uri="config://app-settings") print(result) run_agent(<MCP URL>, <Access token>)
LangGraph MCP Client
  1. 注: LangGraph MCP アダプターリソースのサポートは異なる場合があります。最も信頼性の高いresources/read実装には、上記の MCP クライアントアプローチを使用します。

    import asyncio from mcp import ClientSession from mcp.client.streamable_http import streamablehttp_client from pydantic import AnyUrl async def read_resource(url, token, resource_uri): headers = {"Authorization": f"Bearer {token}"} async with streamablehttp_client(url=url, headers=headers) as ( read_stream, write_stream, callA ): async with ClientSession(read_stream, write_stream) as session: await session.initialize() response = await session.read_resource(uri=AnyUrl(resource_uri)) for content in response.contents: if hasattr(content, 'text') and content.text: print(f"{content.uri}: {content.text}") elif hasattr(content, 'blob') and content.blob: print(f"{content.uri}: <blob, {len(content.blob)} chars base64>") asyncio.run(read_resource( "https://${GatewayEndpoint}/mcp", "${AccessToken}", "config://app-settings" ))

エラー

resources/read オペレーションは、次のタイプのエラーを返すことができます。

  • HTTP ステータスコードの一部として返されるエラー:

    AuthenticationError

    認証情報が無効であるため、リクエストは失敗しました。

    HTTP ステータスコード: 401

    AuthorizationError

    呼び出し元には、リソースを読み取るアクセス許可がありません。

    HTTP ステータスコード: 403

    ResourceNotFoundError

    指定されたリソース URI が存在しないか、ターゲットによって公開されていません。

    HTTP ステータスコード: 404

    ValidationError

    指定された URI の形式が正しくないか、見つかりません。

    HTTP ステータスコード: 400

    InternalServerError

    内部サーバーエラーが発生しました。

    HTTP ステータスコード: 500

  • MCP エラー。これらのタイプのエラーの詳細については、Model Context Protocol (MCP) ドキュメントの「リソース」を参照してください。